/************************************************************************/
/* 	Horizonator
/*	$id$
/*	File	: 					cParams.h
/*	Version	:					1.0
/*	Descript:					 -      
/*								 Horizonator
/*	Autor	:					Morock
/*	Created :					11/30/2006
/************************************************************************/

#pragma once
//#define _CRT_SECURE_NO_DEPRECATE

#include "ng2ParamContainer.h"

#include <Windows.h>
#include <string>
#include <xstring>
#include <iostream>
#include <string.h>
#include <iostream>
#include <io.h>
#include <shlwapi.h>
#include <math.h>
#include <tchar.h>
using namespace std;

typedef struct PARAMS
{
	wchar_t	chOutfname  [MAX_PATH];	//   	
	wchar_t	chHMfname	[MAX_PATH];	//    
	wchar_t	chTMfname	[MAX_PATH];	//    
	int		iOutRezolution;			//    (.)
	float	fHeight;				//      
	float   fTerrainSize;			//   ()
	float   fHeightZeroPoint;		//      (m.)

	PARAMS();
	~PARAMS()
	{
		if (p) delete p;
	};

	//------------------------------------------------------------------------------
	//  
	bool InitParams(int argc);
	//       
	void UseParams();
	//  
	bool TestParams();

private:
	ParamContainer*	p;				// -   (ParamConteiner)
}PARAMS,*LPPARAMS,**LPLPPARAMS;

//------------------------------------------------------------------------------
// 
//------------------------------------------------------------------------------
PARAMS::PARAMS()
{
	ZeroMemory( this, sizeof(PARAMS));
	//Param init
	iOutRezolution = 1024;			//   (.)
	fHeight		= 100.0f;
	fTerrainSize = 5000.0f;
	fHeightZeroPoint = 0.0f;
	
	wcscpy (chOutfname, L"horizon_map.dds"); //    
	//-----------------------------------------------------------------------
	p = new ParamContainer;
	p->initOptions(false,true);
	//  
	p->setHelpString("\nUsage: horizonator.exe ");
}


//  
bool PARAMS::TestParams()
{
	if (fTerrainSize<=0)	{printf("ERROR:bad Terrain Size: must be > 0\n");return false;}
	if(iOutRezolution<=0) {printf("ERROR:bad Out File Resolution: must be > 0\n");return false;}
	div_t div_temp = div(iOutRezolution,2);
	if (div_temp.rem>0)	  {printf("WARNING: Out File Resolution is not deviding by 2");}
	float f_temp2 = 0;
	float f_temp = modf( sqrt(FLOAT(iOutRezolution)),&f_temp2);
	if (f_temp!=0)  {printf("WARNING: Out File Resolution is not ^2\n");}
	if( _waccess(chHMfname,0)!=0){printf("ERROR:File %S not found\n",chHMfname);return false;}
	if( _waccess(chTMfname,0)!=0){printf("ERROR:File %S not found\n",chTMfname);return false;}
	return true;
}

//  
bool PARAMS::InitParams(int argc)
{
	//Add params here
	p->addParam("HMfname",	'H', ParamContainer::required|ParamContainer::filename,	"HeightMap  filename");
	p->addParam("TMfname",	'T', ParamContainer::required|ParamContainer::filename,	"TreeMap  filename");
	p->addParam("Outfname",	'o', ParamContainer::regular |ParamContainer::filename,	"HorizonMap  filename");
	p->addParam("OutRez",	'r', ParamContainer::regular,	"HorizonMap rezolution");
	p->addParam("Height",   'h', ParamContainer::regular,   "Height koeficient");
	p->addParam("TerraSize",'s', ParamContainer::regular,   "Map size (metres)");
	p->addParam("HeightZero",'z',ParamContainer::regular,   "Height Zero Point (metres)");

	//        
	if (argc == 1)
	{
		p->dumpHelp(stdout,true,100);
		return FALSE;
	}
	//   
	ParamContainer::errcode err = p->parseCommandLine(PathGetArgsA(GetCommandLineA()));
	//    
	if(err!=p->errOk) 
	{
		int errpos;
		printf("%s\n", p->getErrCmdLine(errpos).c_str());
		for (;errpos-- > 0;)
			printf(" ");
		printf("^\n");
		printf("%s\n", p->getErrorMessage(err).c_str());
		return FALSE;
	}
	return TRUE;
}

//       
void PARAMS::UseParams()
{
	//BEG - HENTAI!!!
	ParamContainer	tp = *p;
	wchar_t wchtemp[MAX_PATH];
	if(tp["HMfname"]!="")	
	{
		mbstowcs(wchtemp,(tp["HMfname"]).c_str(),MAX_PATH);
		wcscpy(chHMfname, wchtemp);
	}
	if(tp["TMfname"]!="")	
	{
		mbstowcs(wchtemp,(tp["TMfname"]).c_str(),MAX_PATH );
		wcscpy(chTMfname, wchtemp);
	}
	if(tp["Outfname"]!="")	
	{
		mbstowcs(wchtemp,(tp["Outfname"]).c_str(),MAX_PATH );
		wcscpy(chOutfname, wchtemp);
	}
	//END - HENTAI!!!

	if(tp["OutRez"]!="")		
		iOutRezolution = atoi(	(tp["OutRez"]).c_str() );
	if(tp["Height"]!="")		
		fHeight = (float)atof(	(tp["Height"]).c_str() );
	if(tp["TerraSize"]!="")		
		fTerrainSize = (float)atof(	(tp["TerraSize"]).c_str() );
	if(tp["HeightZero"]!="")		
		fHeightZeroPoint = (float)atof(	(tp["HeightZero"]).c_str() );
}